@ECHO OFF
TITLE Update From Web
ECHO Update From Web
ECHO Written by: Jason Faulkner
ECHO SysadminGeek.com
ECHO.
ECHO.

SETLOCAL EnableExtensions

REM Place this script in the folder which contains the utilities to update.
REM Requires WGet to be in the same folder as this script or in a location set in the PATH variable.

REM URL to look for updates on in the event none is specified as a parameter.
REM URL's of interest ---
REM  Sysinternals : http://live.sysinternals.com/tools
REM  NirSoft      : http://www.nirsoft.net/panel
SET URL=http://my.site.com/ToolsFolder

REM If a parameter is specified, use that as the URL.
IF NOT {%1}=={} SET URL=%~1

REM Set this value to 1 to restart tasks that are stopped during the update process.
SET RestartKilledTasks=0


ECHO Detected directory: %~dp0
%~d0
CD %~p0
ECHO.
ECHO.

SET NewFile=.NEW

FOR /F %%A IN ('DIR /B') DO WGet --output-document="%%A%NewFile%" "%URL%/%%A"
REM Delete empty (not found) files.
FORFILES /P . /C "CMD /C IF @fsize==0 DEL /F /Q @path"

SET StartWhenFinished="%TEMP%\StartWhenFinished.tmp.txt"
ECHO ;Terminated tools > %StartWhenFinished%

FOR /F %%A IN ('DIR /B') DO (
	IF EXIST "%%A%NewFile%" (
		ECHO Found new version of: %%A
		REM If the file is running, kill it so it can be replaced.
		FOR /F %%B IN ('TASKLIST') DO (
			IF /I [%%A]==[%%B] (
				ECHO %%B is currently running, killing process.
				ECHO %%A >> %StartWhenFinished%
				TASKKILL /IM "%%B" /T /F
			)
		)
		REM Replace with the new version.
		DEL /F /Q "%%A"
		RENAME "%%A%NewFile%" "%%A"
	)
)

IF {%RestartKilledTasks%}=={1} (
	ECHO.
	ECHO Resuming killed tasks
	FOR /F "usebackq skip=1" %%A IN (%StartWhenFinished%) DO (
		ECHO Starting %%A
		START "Restarting %%A" "%%A"
	)
)

IF EXIST "%StartWhenFinished%" DEL "%StartWhenFinished%"

ENDLOCAL
